/*  ⨬쭮 ࣮ */

#include <stdio.h>
#include <math.h>

#define EPS 0.001
/* . ᫮ 室,  ஥ ⮨  */
#define TMAX 5

double wt,wws,drv,crg,dist,vmax;

/* 㣫   2  ᫥ ⮩ */
double rouf(double x) {
       return(floor(x*100.)*0.01);
}

/* cargo -> capacity */
double c2cc(double c) {
       return c*(1+c/20.);
}

/* cargo -> e.speed */
double c2ev(double c) {
       return vmax*(wt-wws-c)/wt;
}

/* cargo -> f.speed */
double c2fv(double c) {
       double cc=c2cc(c);
       return vmax*(wt-wws-c)/(wt+cc);
}

/* e.speed -> cargo */
double ev2c(double v) {
       return (1-v/vmax)*wt-wws;
}

/* f.speed -> cargo */
double fv2c(double v) {
       double c0,c1=1,c2=ev2c(v);
       if(c1>c2) return -1;
       while (c2-c1>EPS) {
             c0=(c1+c2)/2;
             if(c2fv(c0)<v) c2=c0; else c1=c0;
       }
       return c0;
}

struct variant {
        int ft,et;
        double c,fv,ev;
} var[2][TMAX+1];

int main(int argc, char** argv) {
       int i,j,k0,k1;
       double c,cc,eff0,effcap,effcol;
       fprintf(stderr,"CARGO calculator for galaxy{+/-} v1.1\n");
       if ((argc==5) || (argc==6)) {
          sscanf(argv[1],"%lg",&wt);
          sscanf(argv[2],"%lg",&drv);
          sscanf(argv[3],"%lg",&crg);
          sscanf(argv[4],"%lg",&dist);
          if(argc>5) {
              sscanf(argv[5],"%lg",&wws);
          } else wws=0;
       } else if (argc==1) {
          fprintf(stderr,"     Weight = "); scanf("%lg",&wt);
          fprintf(stderr,"   Tech Drv = "); scanf("%lg",&drv);
          fprintf(stderr,"   Tech Crg = "); scanf("%lg",&crg);
          fprintf(stderr,"   Distance = "); scanf("%lg",&dist);
          fprintf(stderr,"Wpn+Shld wt = "); scanf("%lg",&wws);
       } else {
          fprintf(stderr,"You can either run me without params "
                         "or enter smth like\n"
                         "     cargo <wt> <drv> <crg> <dist> [<wws>]\n");
          return 3;
       }
       if((wt<wws)||(wws<0)||(drv<1)||(crg<1)||(dist<=0)) {
          fprintf(stderr,"Invalid parameters, good bye!\n");
          return 3;
       }

       vmax=drv*20;

       for (i=1;i<=TMAX;++i) {
           c=fv2c(dist/i);
           if(c<1) { var[0][i].c=-1; continue; }
           var[0][i].c=c=rouf(c);
           var[0][i].fv=c2fv(c);
           var[0][i].ev=c2ev(c);
           var[0][i].ft=i;
           var[0][i].et=ceil(dist/var[0][i].ev);
       }

       for (i=1;i<=TMAX;++i) {
           c=ev2c(dist/i);
           if(c<1) { var[1][i].c=-1; continue; }
           var[1][i].c=c=rouf(c);
           var[1][i].fv=c2fv(c);
           var[1][i].ev=c2ev(c);
           var[1][i].ft=ceil(dist/var[1][i].fv);
           var[1][i].et=i;
       }
       if (var[1][TMAX].c<0) {
          fprintf(stderr,"It's too far, I don't like it\n");
          return 2;
       }

            printf(
"FT+ET (   D      C   )  FSpeed  ESpeed  Capacity    Eff0  EffCap  EffCol");
       k0=k1=1;
       while (var[0][k0].c<0) ++k0;
       while (var[1][k1].c<0) ++k1;
       while ((k0<=TMAX) && (k1<=TMAX)) {
             if (var[0][k0].c<var[1][k1].c) {
                i=0; j=k0; ++k0;
             } else {
                i=1; j=k1; ++k1;
             }
             cc=c2cc(var[i][j].c)*crg;
             eff0=cc/(var[i][j].ft+var[i][j].et);
/* ࠢ  㭪樮஢ ਢ  */
             effcap=eff0*exp(-0.18*var[i][j].ft-0.06*var[i][j].et);
/* ࠢ  㭪樮஢ ਢ  */
             effcol=eff0*exp(-0.08*var[i][j].ft-0.03*var[i][j].et);

             printf(
"\n %1d+%1d  (%6.2f %6.2f )  %6.2f  %6.2f  %8.2f  %6.2f  %6.2f  %6.2f",
                 var[i][j].ft, var[i][j].et, wt-wws-var[i][j].c, var[i][j].c,
                 var[i][j].fv, var[i][j].ev,
                 cc, eff0, effcap, effcol);
       }
       return 0;
}


